LinkedHashMap

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.util
Class LinkedHashMap

    java.lang.Object
      java.util.AbstractMap
          java.util.HashMap
              java.util.LinkedHashMap

All Implemented Interfaces:
  Serializable, Cloneable, Map

    public class LinkedHashMap

extends HashMap

Hash table and linked list implementation of the `Map` interface, with predictable iteration order. This implementation differs from `HashMap` in that it maintains a doubly-linked list running through all of its entries. This linked list defines the iteration ordering, which is normally the order in which keys were inserted into the map (insertion-order). Note that insertion order is not affected if a key is re-inserted into the map. (A key `k` is reinserted into a map `m` if `m.put(k, v)` is invoked when `m.containsKey(k)` would return `true` immediately prior to the invocation.)

This implementation spares its clients from the unspecified, generally chaotic ordering provided by `HashMap` (and `Hashtable`), without incurring the increased cost associated with `TreeMap`. It can be used to produce a copy of a map that has the same order as the original, regardless of the original map's implementation:

         void foo(Map m) {
             Map copy = new LinkedHashMap(m);
             ...
         }

This technique is particularly useful if a module takes a map on input, copies it, and later returns results whose order is determined by that of the copy. (Clients generally appreciate having things returned in the same order they were presented.)

A special `constructor` is provided to create a linked hash map whose order of iteration is the order in which its entries were last accessed, from least-recently accessed to most-recently (access-order). This kind of map is well-suited to building LRU caches. Invoking the `put` or `get` method results in an access to the corresponding entry (assuming it exists after the invocation completes). The `putAll` method generates one entry access for each mapping in the specified map, in the order that key-value mappings are provided by the specified map's entry set iterator. No other methods generate entry accesses. In particular, operations on collection-views do not affect the order of iteration of the backing map.

The `removeEldestEntry(Map.Entry)` method may be overridden to impose a policy for removing stale mappings automatically when new mappings are added to the map.

This class provides all of the optional `Map` operations, and permits null elements. Like `HashMap`, it provides constant-time performance for the basic operations (`add`, `contains` and `remove`), assuming the the hash function disperses elements properly among the buckets. Performance is likely to be just slightly below that of `HashMap`, due to the added expense of maintaining the linked list, with one exception: Iteration over the collection-views of a `LinkedHashMap` requires time proportional to the size of the map, regardless of its capacity. Iteration over a `HashMap` is likely to be more expensive, requiring time proportional to its capacity.

A linked hash map has two parameters that affect its performance: initial capacity and load factor. They are defined precisely as for `HashMap`. Note, however, that the penalty for choosing an excessively high value for initial capacity is less severe for this class than for `HashMap`, as iteration times for this class are unaffected by capacity.

Note that this implementation is not synchronized. If multiple threads access a linked hash map concurrently, and at least one of the threads modifies the map structurally, it must be synchronized externally. This is typically accomplished by synchronizing on some object that naturally encapsulates the map. If no such object exists, the map should be "wrapped" using the `Collections.synchronizedMap`method. This is best done at creation time, to prevent accidental unsynchronized access:

        Map m = Collections.synchronizedMap(new LinkedHashMap(...));

A structural modification is any operation that adds or deletes one or more mappings or, in the case of access-ordered linked hash maps, affects iteration order. In insertion-ordered linked hash maps, merely changing the value associated with a key that is already contained in the map is not a structural modification. In access-ordered linked hash maps, merely querying the map with `get` is a structural modification.)

The iterators returned by the `iterator` methods of the collections returned by all of this class's collection view methods are fail-fast: if the map is structurally modified at any time after the iterator is created, in any way except through the iterator's own remove method, the iterator will throw a `ConcurrentModificationException`. Thus, in the face of concurrent modification, the Iterator fails quickly and cleanly, rather than risking arbitrary, non-deterministic behavior at an undetermined time in the future.

Note that the fail-fast behavior of an iterator cannot be guaranteed as it is, generally speaking, impossible to make any hard guarantees in the presence of unsynchronized concurrent modification. Fail-fast iterators throw `ConcurrentModificationException` on a best-effort basis. Therefore, it would be wrong to write a program that depended on this exception for its correctness: the fail-fast behavior of iterators should be used only to detect bugs.

This class is a member of the Java Collections Framework.

Since:
  JDK1.4
Version:
  1.12, 03/12/05
Author:
  Josh Bloch
See Also:
  `Object.hashCode()`, `Collection`, `Map`, `HashMap`, `TreeMap`, `Hashtable`, Serialized Form

Constructor Summary
`LinkedHashMap()` Constructs an empty insertion-ordered `LinkedHashMap` instance with a default capacity (16) and load factor (0.75).
`LinkedHashMap(int initialCapacity)` Constructs an empty insertion-ordered `LinkedHashMap` instance with the specified initial capacity and a default load factor (0.75).
`LinkedHashMap(int initialCapacity, float loadFactor)` Constructs an empty insertion-ordered `LinkedHashMap` instance with the specified initial capacity and load factor.
`LinkedHashMap(int initialCapacity, float loadFactor, boolean accessOrder)` Constructs an empty `LinkedHashMap` instance with the specified initial capacity, load factor and ordering mode.
`LinkedHashMap(Map m)` Constructs an insertion-ordered `LinkedHashMap` instance with the same mappings as the specified map.

Method Summary
`void` | `clear()` Removes all mappings from this map.
`boolean` | `containsValue(Object value)` Returns `true` if this map maps one or more keys to the specified value.
`Object` | `get(Object key)` Returns the value to which this map maps the specified key.

Methods inherited from class java.util.HashMap
`clone, containsKey, entrySet, isEmpty, keySet, put, putAll, remove, size, values`

Methods inherited from class java.util.AbstractMap
`equals, hashCode, toString`

Methods inherited from class java.lang.Object
`getClass, notify, notifyAll, wait, wait, wait`

Methods inherited from interface java.util.Map
`equals, hashCode`

Constructor Detail

### LinkedHashMap

    public LinkedHashMap(int initialCapacity,
                         float loadFactor)

  Constructs an empty insertion-ordered `LinkedHashMap` instance with the specified initial capacity and load factor.

  Parameters:
    `initialCapacity` - the initial capacity.
    `loadFactor` - the load factor.
  Throws:
    `IllegalArgumentException` - if the initial capacity is negative or the load factor is nonpositive.

### LinkedHashMap

    public LinkedHashMap(int initialCapacity)

  Constructs an empty insertion-ordered `LinkedHashMap` instance with the specified initial capacity and a default load factor (0.75).

  Parameters:
    `initialCapacity` - the initial capacity.
  Throws:
    `IllegalArgumentException` - if the initial capacity is negative.

### LinkedHashMap

    public LinkedHashMap()

  Constructs an empty insertion-ordered `LinkedHashMap` instance with a default capacity (16) and load factor (0.75).

### LinkedHashMap

    public LinkedHashMap(Map m)

  Constructs an insertion-ordered `LinkedHashMap` instance with the same mappings as the specified map. The `LinkedHashMap` instance is created with a a default load factor (0.75) and an initial capacity sufficient to hold the mappings in the specified map.

  Parameters:
    `m` - the map whose mappings are to be placed in this map.
  Throws:
    `NullPointerException` - if the specified map is null.

### LinkedHashMap

    public LinkedHashMap(int initialCapacity,
                         float loadFactor,
                         boolean accessOrder)

  Constructs an empty `LinkedHashMap` instance with the specified initial capacity, load factor and ordering mode.

  Parameters:
    `initialCapacity` - the initial capacity.
    `loadFactor` - the load factor.
    `accessOrder` - the ordering mode - `true` for access-order, `false` for insertion-order.
  Throws:
    `IllegalArgumentException` - if the initial capacity is negative or the load factor is nonpositive.

Method Detail

### containsValue

    public boolean containsValue(Object value)

  Returns `true` if this map maps one or more keys to the specified value.

  Specified by:
    `containsValue` in interface `Map`
  Overrides:
    `containsValue` in class `HashMap`
  Parameters:
    `value` - value whose presence in this map is to be tested.
  Returns:
    `true` if this map maps one or more keys to the specified value.

### get

    public Object get(Object key)

  Returns the value to which this map maps the specified key. Returns `null` if the map contains no mapping for this key. A return value of `null` does not necessarily indicate that the map contains no mapping for the key; it's also possible that the map explicitly maps the key to `null`. The `containsKey` operation may be used to distinguish these two cases.

  Specified by:
    `get` in interface `Map`
  Overrides:
    `get` in class `HashMap`
  Parameters:
    `key` - key whose associated value is to be returned.
  Returns:
    the value to which this map maps the specified key.
  See Also:
    `HashMap.put(Object, Object)`

### clear

    public void clear()

  Removes all mappings from this map.

  Specified by:
    `clear` in interface `Map`
  Overrides:
    `clear` in class `HashMap`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help

PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD